
; ################################################
; ###                                          ###
; ###   short water routine by Azure
; ###    based on a routine by Graham (72 bytes)
; ###                                          ###
; ###  written for the #amycoders competition  ###
; ################################################
; ##                                            ##
; Originally this was grahams first version
;of his watercompo entry (72 bytes). I said to him
;"We can make that shorter" - so we optimized it by some
;bytes. Later Graham&me continued optimizing alone.
; 
; ## Azure transformed this into a nice 44/46   ##
; ##             bytes Routine!                 ##
; ##                                            ##
; ## Actually I am suprised, that this does     ##
; ## still look water alike :)                  ##
; ## 25.11.1997                                 ##
; ##                                            ##
; ################################################

        section "water",code    ; the fun begins


clearwater=0    ;set this to 1 to remove even the last ripple (adds 2 bytes)
                ;in the buffer-edges,who are d0.b dependant.
                ;(adds two bytes)
Water_do:
f
        if      clearwater-1

                lea     data,a1
                
                moveq   #1,d7
                move.l  a1,a2
                add.l   -(a1),a2
                eor.w   d7,(a1)
                add.l   (a1)+,a1
        else
                lea     data-5,a1

                move.l  (a1),d7
                lea     5(a1,d7.l),a2
                eor.w   #1,(a1)
                add.l   (a1)+,a1
        endif   
.yo
        if      clearwater-1
                move.b  d0,(a2)+
        endif           
                move.b  (a1)+,d0
                add.b   -256(a1),d0
                add.b   256(a1),d0
                add.w   (a1),d0
                asr.b   #1,d0
                sub.b   (a2),d0
                spl     d1
                and.b   d1,d0       ; damping ??!? :)
        if      clearwater      
                move.b  d0,(a2)+
        endif   
                move.b  d0,(a0)+
                addq.w  #1,d7
                bne.b   .yo
e               
                rts

Water_Init:     
                rts

        
Water_Drop:
                move.l  data-5,d2
                bchg    #16,d2
                lea     data,a0
                add.l   d2,a0
                lsl.w   #8,d1
                and.l   #$ff00,d1
                add.l   d1,a0
                move.b  #-64,(a0,d0.w)
                rts

         section "waterbss",bss
                ds.b    512
data:           ds.l    65536

